#!/usr/bin/perl
##
#
# $Author: sbarn $
# $Revision: 1.2 $
# $Log: update_journal.pl,v $
# Revision 1.2  2004-04-18 12:53:46-04  sbarn
# Initial Version
#
# 
#
##

# update_journal.pl
# Update the journal table to close out entries
# This is intended to be run from a cron job
# Copyright 2004 D. Scott Barninger <barninger@fairfieldcomputers.com>

#--------------------------------------------------------------------#
# Program Configuration
#

# the mysql database name
my $database = "database";
# mysql host
my $host = "localhost";
# mysql user
my $user = "dbuser";
# mysql password
my $password = "dbpassword";
# the end of the official operations day
my $day_stop = "03:59:59";
# number of days to keep entries active
my $days_to_keep = "5";

#--------------------------------------------------------------------#

use DBI();
use Date::EzDate;

# get the current date and subtract $days_to_keep
my($sysdate,$systime,$sysyear,$sysmon,$sysmday) = &SysDate;
my $temp_date = Date::EzDate->new($sysdate);
$temp_date = $temp_date - $days_to_keep;
# put it in the proper format
my $keep_date = $temp_date->{'{year}-{month number base 1}-{day of month}'};

# connect to database
my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host","$user","$password",
		{'RaiseError' => 1}) || die("Unable to connect to database.");
# prepare query
my $sth = $dbh->prepare("UPDATE journal 
	SET condition = \"CLOSED\" 
	WHERE date_time <= \"$keep_date $day_stop\"
	");

$sth->execute() || die("Unable to execute query updating table journal.");
$sth->finish();
$dbh->disconnect();

print "Successfully updated the journal table.\n";
print "Records older than $keep_date $day_stop have been CLOSED.\n";

#-------------------------------------------------------------------#
# Function SysDate
# Description: get current date/time
#
sub SysDate {
	# usage:  my($sysdate,$systime,$sysyear,$sysmon,$sysmday) = &SysDate;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
	if (length ($min) == 1) {$min = '0'.$min;}
	if (length ($sec) == 1) {$sec = '0'.$sec;}
	# since localtime returns the month as 0-11
	$mon = $mon + 1;
	if (length ($mon) == 1) {$mon = '0'.$mon;}
	if (length ($mday) == 1) {$mday = '0'.$mday;}
	# since localtime returns the year as the number of years since 1900
	# ie year is 100 in the year 2000 (so is y2k OK)
	$year = $year + 1900;
	my $date = "$year-$mon-$mday";
	my $time = "$hour:$min:$sec";
	return($date,$time,$year,$mon,$mday);
}
